;8-damen-doof-listen.scm
; Der wesentliche Unterschied ist, dass nur mit den nachfolgenden
; Feldern gesucht wird.
;(load "breakpoint.scm")

; ========== Definition des Spielfeldes ===========================
(define
  (felder x y groesse akku)
  (cond
    ((zero? x) akku)
    ((zero? y) (felder (- x 1) groesse groesse akku))
    (else
     (felder x (- y 1) groesse (cons (list x y) akku)))))
; Aufrufhuelle
(define (gib-felder n) (felder n n n '()))

; ========== Einbau Praedikate ====================================
; verallgemeinerte Prüffunktion:
(define
  (bedroht? funktion dame damen-liste)
  (member (funktion dame) (map funktion damen-liste)))

(define
  (wird-bedroht? dame damen-liste)
  (or
   (bedroht? first dame damen-liste)
   (bedroht? second dame damen-liste)
   (bedroht? (lambda (feld) (- (first feld) (second feld))) dame damen-liste)
   (bedroht? (lambda (feld) (+ (first feld) (second feld))) dame damen-liste)))

(define
  (liste-ok? damen-liste)
  (cond
    [(null? damen-liste)]
    [(null? (rest damen-liste))]
    [(wird-bedroht? (first damen-liste) (rest damen-liste)) #f]
    [else (liste-ok? (rest damen-liste))]))
  
;;; ===== die eigentliche Suchfunktion =====
(define
  (fuelle felder damen-liste zielgroesse)
  ;(writeln damen-liste)
   (cond
     [(= (length damen-liste) zielgroesse)
      (if
       (liste-ok? damen-liste)
       damen-liste                     ; Erfolgsfall
       #f)]                            ; Misserfolgsfall
     [(null? felder) #f]               ; Misserfolgsfall
     [(fuelle (rest felder) (cons (first felder) damen-liste) zielgroesse)]
     [else
      (fuelle (rest felder) damen-liste zielgroesse)]))

; Aufrufhuelle:
(define (suche-belegung n) (fuelle (gib-felder n) '() n))
; globale Variable zur Festlegung der Groesse des Feldes
(define zeilen-spalten 6)
(define spiel-feld (gib-felder zeilen-spalten))
; Test mit Zeitmessung:
(load "laufzeiten.scm")
(Zeit 'start)
(suche-belegung zeilen-spalten)
(Zeit 'miss)